#version unofficial MegaPov 0.7;

#declare m_slope = slope_map {
  [0    < 0, 1>]
  [0.4  < 1, 1>]
  [0.45 < 0, 0>]
  [0.5  <-1, 1>]
  [1    < 0,-1>]
}

#declare StoneTex = texture {
  pigment {
    granite
    turbulence 0.6
    color_map {
      [0.00, 0.32 color rgb <0.91, 0.79, 0.79> color rgb <0.92, 0.91, 0.87>]
      [0.32, 0.45 color rgb <0.92, 0.91, 0.87> color rgb <0.89, 0.87, 0.78>]
      [0.45, 0.62 color rgb <0.89, 0.87, 0.78> color rgb <0.78, 0.79, 0.79>]
      [0.62, 0.73 color rgb <0.78, 0.79, 0.79> color rgb <0.85, 0.81, 0.74>]
      [0.73, 0.86 color rgb <0.85, 0.81, 0.74> color rgb <0.65, 0.66, 0.66>]
      [0.86, 1.00 color rgb <0.65, 0.66, 0.66> color rgb <0.91, 0.79, 0.79>]
    }
  }  
  normal { 
    average 
    normal_map {
      [1 granite 0.5]
      [1 wrinkles 4 turbulence 0.5 slope_map {m_slope} scale <2, 1, 2>/3]
    }
  }
  finish {ambient 0.0 diffuse 0.6 brilliance 2}    
}
texture {
  pigment {
    granite
    turbulence 0.7
    color_map {
      [0.00 0.29 color rgbf <0.69, 0.71, 0.75, 0.6> color rgbf <0.87, 0.78, 0.42, 0.6>]
      [0.29 0.31 color rgbf <0.87, 0.78, 0.42, 0.6> color rgbf <0.69, 0.71, 0.75, 0.6>]
      [0.31 0.43 color rgbf <0.69, 0.71, 0.75, 0.6> color rgbf <0.83, 0.96, 0.78, 0.6>]
      [0.43 0.64 color rgbf <0.83, 0.96, 0.78, 0.6> color rgbf <0.65, 0.65, 0.65, 0.6>]
      [0.64 0.69 color rgbf <0.65, 0.65, 0.65, 0.6> color rgbf <0.95, 0.95, 0.95, 0.6>]
      [0.69 1.00 color rgbf <0.95, 0.95, 0.95, 0.6> color rgbf <0.69, 0.71, 0.75, 0.6>]
    }
    scale 0.1*<1,2,2>
    rotate <0,90,-60>
  }
  normal {
    average 
    normal_map {
      [1 granite 0.5 scale 0.5]
      [1 wrinkles 4 turbulence 0.5 slope_map {m_slope} scale <2, 1, 2>/3.5]
     
    }    
  }
  finish {specular 0.125 ambient 0.0 diffuse 0.65 crand 0.125 brilliance 2} 
  scale 1.75
}

#macro m_strata (freq, amnt)
  function {noise3d(y*freq+noise3d(y+noise3d(x*4,y*4,z*4),z,x)*amnt,0,0)}
#end

#declare Rock_L1 = texture {
  pigment {
    m_strata (20, 1)
    turbulence 0.5
    color_map {
      [0.00 0.29 color Gray80 color Gray85]
      [0.29 0.31 color Gray85 color Gray80]
      [0.31 0.43 color Gray80 color White ]
      [0.43 0.64 color White  color Gray80]
      [0.64 0.69 color Gray80 color Gray95]
      [0.69 1.00 color Gray95 color Gray80]
    }
    scale 4
  }
  finish {ambient 0.0 diffuse 0.6 brilliance 3}
  normal {crackle 0.75 turbulence 0.5}
  rotate 10*z scale 2
}

#declare Rock_L2 = texture {
  pigment {
    crackle
    turbulence 0.5
    solid
    color_map {
      [0.0 color rgbf <0.9, 0.8, 0.8, 0.6>]
      [0.2 color Gray85 filter 0.6]
      [0.4 color Gray75 filter 0.6]
      [0.6 color White  filter 0.6]
      [1.0 color rgbf <0.9, 0.8, 0.7, 0.6>]
    }
  }
  finish {ambient 0.0 diffuse 0.65 specular 0.125 brilliance 2}
  normal {crackle 0.75 turbulence 0.5}
  scale <6,18,6>
}

#declare RockTex = texture {Rock_L1 scale 0.5} texture {Rock_L2 scale 0.55}

#declare Ground_L1 = texture {
  pigment {
    crackle 
    turbulence 0.25 
    scale 0.01 
    pigment_map {
      [0.0 MediumForestGreen]
      [0.5 MediumWood]
      [1.0 DarkWood]
    }
  }
  normal {crackle turbulence 0.25 scale 0.01}
  finish {ambient 0.0 diffuse 0.65}
}

#declare Ground_L2 = texture {
  pigment {rgb <0.4,0.3,0.0>}
  normal {average normal_map {[bozo scale 0.1][agate scale 0.1]}}
  finish {ambient 0.0 diffuse 0.65}
}

#declare Ground_L3 = texture {
  wrinkles 
  turbulence 0.25 
  scale 0.2
  texture_map{
    [0.50 Ground_L2]
    [0.55 Ground_L1]
  }
}

#declare Ground_L4 = texture{
  gradient y
  texture_map {
    [0.5 Ground_L3]
    [1.0 Ground_L1]
  }
}

#declare GroundTex = texture {
  wrinkles 
  turbulence 0.25 
  scale 0.2
  texture_map {
    [0.50 Ground_L4]
    [0.60 Ground_L1]
  }
}  

#declare Oak_TrunkTex = texture {
  pigment {image_map {tga "OakBarkTex" map_type 0 interpolate 2}}
  normal {granite 0.4 scale 0.02}
  finish {ambient 0.2 diffuse 1.0 phong 0.1 phong_size 150}
  scale <1,200/132,1>
}

#declare Oak_TrunkTexPlain = texture {
  pigment {color rgb <0.392,0.365,0.251>}
  finish {ambient 0.2 diffuse 1.0 phong 0.1 phong_size 150}
}


#declare Oak_LeafTexGreen = texture {
  pigment {image_map {tga "OakLeafTexGreen.tga" map_type 0 interpolate 2}}
  finish {ambient 0.2 diffuse 1.0 phong 0.3 phong_size 150}
}

#declare Oak_LeafTexBrown = texture {
  pigment {image_map {tga "OakLeafTexBrown.tga" map_type 0 interpolate 2}}
  finish {ambient 0.2 diffuse 1.0 phong 0.3 phong_size 150}
}

#declare Oak_LeafTexRed = texture {
  pigment {image_map {tga "OakLeafTexRed.tga" map_type 0 interpolate 2}}
  finish {ambient 0.2 diffuse 1.0 phong 0.3 phong_size 150}
}

#declare Oak_LeafTexPlain = texture {
  pigment {color rgb <0.325,0.453,0.024>}
  finish {ambient 0.2 diffuse 1.0 phong 0.3 phong_size 150}
}

